<template>
  <div>
    <q-table
      title="Semua User"
      class="table-produk-saya"
      :data="data"
      :columns="columns"
      row-key="id"
      :pagination.sync="pagination"
      :loading="loading"
      :filter="filter"
      @request="onRequest"
      binary-state-sort
    >
      <template v-slot:top-right style="color: white !important;">
        <q-input borderless dense debounce="300" v-model="filter" placeholder="Cari Produk" @input="onRequest" color="white">
          <template v-slot:append style="color: white">
            <q-icon name="search"  />
          </template>
        </q-input>
      </template>
      <template v-slot:body="props">
        <q-tr :props="props" :key="`m_${props.row.index}`">
          <q-td
            style="width: 30px"
            key="index"
            :props="props"
          >
            {{ props.row.index }}.
          </q-td>
          <q-td key="level_name" :props="props" >{{ props.row.level_name }}</q-td>
          <q-td key="level_price" :props="props" >{{ formatRupiah(props.row.level_price, "Rp.") }}</q-td>
          <q-td key="page_access" :props="props" >
            <q-badge class="q-mr-xs" v-for="(data, index) in props.row.page_access.split(',')" v-bind:key="index" :label="data" color="blue" />
          </q-td>
          <q-td key="status" :props="props" >
            <q-toggle @input="changeStatus(props.row.id, props.row.status, props.row.index)" class="q-mr-xs" :label="(props.row.status) ? 'Aktif' : 'Tidak Aktif'" :color="(props.row.status == 1) ? 'green' : 'red'" :value="props.row.status" :true-value="true" :false-value="false" :model-value="[true, false]" />
          </q-td>
          <q-td key="actions" :props="props" style="padding-left: 0; padding-right: 0">
            <q-btn-group>
              <q-btn size="10px" color="primary" >Detail</q-btn>
              <q-btn size="10px" color="orange" >Edit</q-btn>
              <q-btn size="10px" color="red" type="a" :to="`/level/hapus/${props.row.id}`">Hapus</q-btn>
            </q-btn-group>
          </q-td>
        </q-tr>
      </template>
    </q-table>
  </div>
</template>

<script>
export default {
  name: "TabelLevel",
  data () {
    return {
      filter: '',
      loading: false,
      token: localStorage.getItem("token"),
      pagination: {
        sortBy: 'index',
        descending: true,
        page: 1,
        rowsPerPage: 5,
        rowsNumber: 10
      },
      columns: [
        {
          name: 'index',
          required: true,
          label: 'No',
          align: 'left',
          field: 'index',
          format: val => `${val}`,
          sortable: true
        },
        { name: 'level_name', align: 'center', label: 'Nama Level', field: 'level_name', sortable: true },
        { name: 'level_price', align: 'center', label: 'Harga', field: 'level_price', sortable: true },
        { name: 'page_access', align: 'center', label: 'Akses Halaman', field: 'page_access', sortable: true },
        { name: 'status', align: 'center', label: 'Status', field: 'status', sortable: true },
        { name: 'actions', align: 'center', label: 'Aksi', field: 'id', sortable: false },
      ],
      data: [],
    }
  },
  filters: {
    currency(price) {
      return new Intl.NumberFormat("id-ID", {
        style: "currency",
        currency: "IDR",
        minimumFractionDigits: 2
      }).format(price);
    }
  },
  mounted () {
    // get initial data from server (1st page)
    this.onRequest({
      pagination: this.pagination,
      filter: undefined
    })
  },
  methods: {
    changeStatus: function (idLevel, status, index) {
      let formData = new FormData()
      formData.append("id_level", idLevel)
      formData.append("status", status)
      this.$q.loading.show()
      this.$axios.post("api/level/update-status", formData)
      .then(sukses => {
        this.$q.loading.hide()
        this.onRequest({ filter: this.filter, pagination : this.pagination})
      })
      .catch(error => {
        this.$q.loading.hide()
        this.$q.notify({
          message: "Ada Kesalahan",
          color: "red",
          position: "top"
        })
      })
    },
    hapusProduct: function (id) {
      alert(id)
    },
    showImage(val) {
      this.$q.dialog({
        message: `<img src="${val}" style="width: 100%" />`,
        html: true,
      })
    },
    onRequest (props) {
      const { descending, page, rowsNumber, rowsPerPage, sortBy } = props.pagination;
      const filter = props.filter
      if (! descending) {
        this.pagination.descending = true
      }
      this.loading = true
      let apiUrl =
        `api/level/list?page=${page}&perPage=${rowsPerPage}&sortBy=${sortBy}&filter=${filter}&descending=${descending}`
      let config = {
        method: "post",
        url: apiUrl ,
        headers: {
          Authorization: "Bearer " + this.token
        }
      }
      this.$axios(config)
        .then(response => {
          let data = response.data
          this.data = data.data
          this.data.forEach((row, index) => {
            row.index = index + 1 + ((page-1)*rowsPerPage)
          })
          this.pagination = {
            sortBy: 'index',
            descending: descending,
            page: data.current_page,
            rowsPerPage: data.per_page,
            rowsNumber: data.total
          }
        })
        .catch(error => {
        })
        .then(always => {
          this.loading = false
        })
    },
    formatRupiah(angka, prefix){
      var number_string = angka.replace(/[^,\d]/g, '').toString(),
        split   		= number_string.split(','),
        sisa     		= split[0].length % 3,
        rupiah     		= split[0].substr(0, sisa),
        ribuan     		= split[0].substr(sisa).match(/\d{3}/gi);
      // tambahkan titik jika yang di input sudah menjadi angka ribuan
      if(ribuan){
        let separator = sisa ? '.' : '';
        rupiah += separator + ribuan.join('.');
      }
      rupiah = split[1] != undefined ? rupiah + ',' + split[1] : rupiah;
      return prefix == undefined ? rupiah : (rupiah ? 'Rp. ' + rupiah : '');
    },
  }
}
</script>

<style lang="sass" scoped>
.q-table--no-wrap td
  white-space: normal

  .table-produk-saya

    .q-table__top,
    .q-table__bottom,
    thead tr:first-child th
      /* bg color is important for th; just specify one */
      background-color: #009688
      color: white
      font-size: 16px

    thead tr th
      position: sticky
      z-index: 1
    thead tr:first-child th
      top: 0

    /* this is when the loading indicator appears */
    &.q-table--loading thead tr:last-child th
      /* height of all previous header rows */
      top: 48px
</style>

